<?php
declare(strict_types=1);

namespace IntiTest\Wp\Middleware;

use Doctrine\DBAL\Exception;
use DomainException;
use Inti\Db\Connection\ConnectionManager;
use Inti\Wp\Middleware\ConfigProvider;

trait WordPressTestCase
{
    private array $providers = [
        \Inti\Db\ConfigProvider::class,
        \Inti\Wp\Plugin\ConfigProvider::class,
        ConfigProvider::class,
    ];

    private array $config = [
        'db.connections' => [
            'connections' => [
                'default' => [
                    'host' => 'autokreso-baza',
                    'user' => 'root',
                    'password' => 'JrtbKN9WD',
                    'dbname' => 'inti',
                ],
            ],
        ],
    ];

    protected function setUpWordPress(): void
    {
        if (!defined('ABSPATH')) {
            define('ABSPATH', realpath(__DIR__ . '/../wordpress') . '/');
        }

        $container = $this->createContainer();
        /** @var ConnectionManager $connectionManager */
        $connectionManager = $container->get(ConnectionManager::class);
        $conn = $connectionManager->get('default');
        $this->container = null;

        try {
            $conn->executeQuery('SELECT option_value FROM wp_options WHERE option_name = ?', ['siteurl']);
        } catch (Exception $e) {
            throw new DomainException(sprintf(
                '%s: WordPress must be installed.',
                __METHOD__
            ));
        }
    }
}
